"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var PatternMatcher_1 = require("./PatternMatcher");
var smsMatcherProviders = {
    'TrueMoney Wallet': [
        // == TrueMoney ==
        match('TrueMoney', 'ชำระเงิน {{amount:number}}บ. ให้ {{to}} คงเหลือ {{balance:number}}บ. ({{transactionId}})', { type: 'pay' }),
        match('TrueMoney', 'You have paid {{amount:number}} Baht using {{via}}. Your balance is {{balance:number}} Baht (transaction {{transactionId}})', { type: 'pay' })
    ],
    KBANK: [
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} transferred {{amount:number}} Baht to {{to}} Outstanding Balance {{balance:number}} Baht.', { type: 'transfer' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} transferred {{amount:number}} Baht to {{to}}', { type: 'transfer' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} Withdrawal{{amount:number}} Outstanding Balance{{balance:number}} Baht.', { type: 'withdraw' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} Withdrawal{{amount:number}} Baht.', { type: 'withdraw' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{to}} Deposit{{amount:number}} Outstanding Balance{{balance:number}} Baht.', { type: 'deposit' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{to}} Deposit{{amount:number}} Baht.', { type: 'deposit' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} credited {{amount:number}} Baht to {{to}} Outstanding Balance {{balance:number}} Baht.', { type: 'credit' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{from}} credited {{amount:number}} Baht to {{to}}', { type: 'credit' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{to}} received {{amount:number}} Baht from {{from}} Outstanding Balance {{balance:number}} Baht.', { type: 'receive' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{to}} received {{amount:number}} Baht from {{from}}', { type: 'receive' }),
        match('KBank', '{{date:kbank_date}} {{time:time}} {{subject}} Outstanding Balance {{balance:number}} Baht.', { type: 'info' }),
        match('KBank', 'ชำระ {{amount:number}}บ บัตร {{from}}@{{to}} {{time:time}}น เหลือ {{balance:number}}บ', { type: 'pay' }),
        match('KBank', 'คืนเงิน {{amount:number}}บ บัตร {{to}}@{{from}} {{time:time}}น เหลือ {{balance:number}}บ', { type: 'refund' })
    ]
};
function parseSMS(text, sender) {
    for (var _i = 0, _a = Object.keys(smsMatcherProviders); _i < _a.length; _i++) {
        var provider = _a[_i];
        for (var _b = 0, _c = smsMatcherProviders[provider]; _b < _c.length; _b++) {
            var smsMatcher = _c[_b];
            if (sender && sender !== smsMatcher.from) {
                continue;
            }
            var result = smsMatcher.patternMatcher.execute(text);
            if (!result) {
                continue;
            }
            return __assign({ provider: provider }, smsMatcher.extra, result);
        }
    }
    return null;
}
exports.parseSMS = parseSMS;
function match(from, pattern, extra) {
    return {
        from: from,
        patternMatcher: PatternMatcher_1.compilePattern(pattern),
        extra: extra
    };
}
//# sourceMappingURL=index.js.map